Skip to content
v2.276.0

CfnReplicationTask L1 construct ​

The AWS::DMS::ReplicationTask resource creates an AWS DMS replication task.

Example ​

ts
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_dms as dms } from 'aws-cdk-lib';
const cfnReplicationTask = new dms.CfnReplicationTask(this, 'MyCfnReplicationTask', {
  migrationType: 'migrationType',
  replicationInstanceArn: 'replicationInstanceArn',
  sourceEndpointArn: 'sourceEndpointArn',
  tableMappings: 'tableMappings',
  targetEndpointArn: 'targetEndpointArn',

  // the properties below are optional
  cdcStartPosition: 'cdcStartPosition',
  cdcStartTime: 123,
  cdcStopPosition: 'cdcStopPosition',
  replicationTaskIdentifier: 'replicationTaskIdentifier',
  replicationTaskSettings: 'replicationTaskSettings',
  resourceIdentifier: 'resourceIdentifier',
  tags: [{
    key: 'key',
    value: 'value',
  }],
  taskData: 'taskData',
});
python
from aws_cdk import CfnTag
# The code below shows an example of how to instantiate this type.
# The values are placeholders you should change.
from aws_cdk import aws_dms as dms

cfn_replication_task = dms.CfnReplicationTask(self, "MyCfnReplicationTask",
    migration_type="migrationType",
    replication_instance_arn="replicationInstanceArn",
    source_endpoint_arn="sourceEndpointArn",
    table_mappings="tableMappings",
    target_endpoint_arn="targetEndpointArn",

    # the properties below are optional
    cdc_start_position="cdcStartPosition",
    cdc_start_time=123,
    cdc_stop_position="cdcStopPosition",
    replication_task_identifier="replicationTaskIdentifier",
    replication_task_settings="replicationTaskSettings",
    resource_identifier="resourceIdentifier",
    tags=[CfnTag(
        key="key",
        value="value"
    )],
    task_data="taskData"
)
java
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import software.amazon.awscdk.services.dms.*;

CfnReplicationTask cfnReplicationTask = CfnReplicationTask.Builder.create(this, "MyCfnReplicationTask")
        .migrationType("migrationType")
        .replicationInstanceArn("replicationInstanceArn")
        .sourceEndpointArn("sourceEndpointArn")
        .tableMappings("tableMappings")
        .targetEndpointArn("targetEndpointArn")

        // the properties below are optional
        .cdcStartPosition("cdcStartPosition")
        .cdcStartTime(123)
        .cdcStopPosition("cdcStopPosition")
        .replicationTaskIdentifier("replicationTaskIdentifier")
        .replicationTaskSettings("replicationTaskSettings")
        .resourceIdentifier("resourceIdentifier")
        .tags(List.of(CfnTag.builder()
                .key("key")
                .value("value")
                .build()))
        .taskData("taskData")
        .build();
csharp
// Install: dotnet add package Amazon.CDK.Lib
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
using Amazon.CDK.AWS.DMS;

var cfnReplicationTask = new CfnReplicationTask(this, "MyCfnReplicationTask", new CfnReplicationTaskProps {
    MigrationType = "migrationType",
    ReplicationInstanceArn = "replicationInstanceArn",
    SourceEndpointArn = "sourceEndpointArn",
    TableMappings = "tableMappings",
    TargetEndpointArn = "targetEndpointArn",

    // the properties below are optional
    CdcStartPosition = "cdcStartPosition",
    CdcStartTime = 123,
    CdcStopPosition = "cdcStopPosition",
    ReplicationTaskIdentifier = "replicationTaskIdentifier",
    ReplicationTaskSettings = "replicationTaskSettings",
    ResourceIdentifier = "resourceIdentifier",
    Tags = new [] { new CfnTag {
        Key = "key",
        Value = "value"
    } },
    TaskData = "taskData"
});
go
// Install: go get github.com/aws/aws-cdk-go/awscdk/v2
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import "github.com/aws/aws-cdk-go/awscdk"

cfnReplicationTask := awscdk.Aws_dms.NewCfnReplicationTask(this, jsii.String("MyCfnReplicationTask"), &CfnReplicationTaskProps{
	MigrationType: jsii.String("migrationType"),
	ReplicationInstanceArn: jsii.String("replicationInstanceArn"),
	SourceEndpointArn: jsii.String("sourceEndpointArn"),
	TableMappings: jsii.String("tableMappings"),
	TargetEndpointArn: jsii.String("targetEndpointArn"),

	// the properties below are optional
	CdcStartPosition: jsii.String("cdcStartPosition"),
	CdcStartTime: jsii.Number(123),
	CdcStopPosition: jsii.String("cdcStopPosition"),
	ReplicationTaskIdentifier: jsii.String("replicationTaskIdentifier"),
	ReplicationTaskSettings: jsii.String("replicationTaskSettings"),
	ResourceIdentifier: jsii.String("resourceIdentifier"),
	Tags: []CfnTag{
		&CfnTag{
			Key: jsii.String("key"),
			Value: jsii.String("value"),
		},
	},
	TaskData: jsii.String("taskData"),
})

Initializer ​

ts
new CfnReplicationTask(scope: Construct, id: string, props: CfnReplicationTaskProps)
python
CfnReplicationTask(scope: Construct, id: str, props: CfnReplicationTaskProps)
java
new CfnReplicationTask(Construct scope, String id, CfnReplicationTaskProps props)
csharp
new CfnReplicationTask(Construct scope, string id, CfnReplicationTaskProps props)
go
NewCfnReplicationTask(Scope Construct, Id *string, Props CfnReplicationTaskProps)

Construct Props ​

cdcStartPositionoptionalstringcdc_start_positionoptionalstrcdcStartPositionoptionalStringCdcStartPositionoptionalstringCdcStartPositionoptional*string#
Indicates when you want a change data capture (CDC) operation to start.
notes

Use either CdcStartPosition or CdcStartTime to specify when you want a CDC operation to start. Specifying both values results in an error.

The value can be in date, checkpoint, log sequence number (LSN), or system change number (SCN) format.

Here is a date example: --cdc-start-position "2018-03-08T12:12:12"

Here is a checkpoint example: --cdc-start-position "checkpoint:V1#27#mysql-bin-changelog.157832:1975:-1:2002:677883278264080:mysql-bin-changelog.157832:1876#0#0#*#0#93"

Here is an LSN example: --cdc-start-position “mysql-bin-changelog.000024:373”

When you use this task setting with a source PostgreSQL database, a logical replication slot should already be created and associated with the source endpoint. You can verify this by setting the slotName extra connection attribute to the name of this logical replication slot. For more information, see Extra Connection Attributes When Using PostgreSQL as a Source for AWS DMS in the AWS Database Migration Service User Guide .

cdcStartTimeoptionalnumbercdc_start_timeoptionalint | floatcdcStartTimeoptionalNumberCdcStartTimeoptionaldoubleCdcStartTimeoptional*float64#
Indicates the start time for a change data capture (CDC) operation.
cdcStopPositionoptionalstringcdc_stop_positionoptionalstrcdcStopPositionoptionalStringCdcStopPositionoptionalstringCdcStopPositionoptional*string#
Indicates when you want a change data capture (CDC) operation to stop.

The value can be either server time or commit time.

Here is a server time example: --cdc-stop-position "server_time:2018-02-09T12:12:12"

Here is a commit time example: --cdc-stop-position "commit_time: 2018-02-09T12:12:12"

migrationTypestringmigration_typestrmigrationTypeStringMigrationTypestringMigrationType*stringrequired#
The migration type.

Valid values: full-load | cdc | full-load-and-cdc

replicationInstanceArnstringreplication_instance_arnstrreplicationInstanceArnStringReplicationInstanceArnstringReplicationInstanceArn*stringrequired#
The Amazon Resource Name (ARN) of a replication instance.
replicationTaskIdentifieroptionalstringreplication_task_identifieroptionalstrreplicationTaskIdentifieroptionalStringReplicationTaskIdentifieroptionalstringReplicationTaskIdentifieroptional*string#
An identifier for the replication task.

Constraints:

  • Must contain 1-255 alphanumeric characters or hyphens.
  • First character must be a letter.
  • Cannot end with a hyphen or contain two consecutive hyphens.
replicationTaskSettingsoptionalstringreplication_task_settingsoptionalstrreplicationTaskSettingsoptionalStringReplicationTaskSettingsoptionalstringReplicationTaskSettingsoptional*string#
Overall settings for the task, in JSON format.
notes

For more information, see Specifying Task Settings for AWS Database Migration Service Tasks in the AWS Database Migration Service User Guide .

resourceIdentifieroptionalstringresource_identifieroptionalstrresourceIdentifieroptionalStringResourceIdentifieroptionalstringResourceIdentifieroptional*string#
A display name for the resource identifier at the end of the `EndpointArn` response parameter that is returned in the created `Endpoint` object.
notes

The value for this parameter can have up to 31 characters. It can contain only ASCII letters, digits, and hyphen ('-'). Also, it can't end with a hyphen or contain two consecutive hyphens, and can only begin with a letter, such as Example-App-ARN1 .

For example, this value might result in the EndpointArn value arn:aws:dms:eu-west-1:012345678901:rep:Example-App-ARN1 . If you don't specify a ResourceIdentifier value, AWS DMS generates a default identifier value for the end of EndpointArn .

sourceEndpointArnstringsource_endpoint_arnstrsourceEndpointArnStringSourceEndpointArnstringSourceEndpointArn*stringrequired#
An Amazon Resource Name (ARN) that uniquely identifies the source endpoint.
tableMappingsstringtable_mappingsstrtableMappingsStringTableMappingsstringTableMappings*stringrequired#
The table mappings for the task, in JSON format.

For more information, see Using Table Mapping to Specify Task Settings in the AWS Database Migration Service User Guide .

tagsoptionalCfnTag[]tagsoptionaltyping.List[CfnTag]tagsoptionalList<CfnTag>TagsoptionalCfnTag[]Tagsoptional*[]CfnTag#
One or more tags to be assigned to the replication task.
targetEndpointArnstringtarget_endpoint_arnstrtargetEndpointArnStringTargetEndpointArnstringTargetEndpointArn*stringrequired#
An Amazon Resource Name (ARN) that uniquely identifies the target endpoint.
taskDataoptionalstringtask_dataoptionalstrtaskDataoptionalStringTaskDataoptionalstringTaskDataoptional*string#
Supplemental information that the task requires to migrate the data for certain source and target endpoints.

For more information, see Specifying Supplemental Data for Task Settings in the AWS Database Migration Service User Guide.

Properties ​

attrReplicationTaskArnstringattr_replication_task_arnstrattrReplicationTaskArnStringAttrReplicationTaskArnstringAttrReplicationTaskArn*string#
The ARN of the ReplicationTask.

Also serves the purpise of Primary Identifier.

cdcStartPositionmay be undefinedstringcdc_start_positionmay be undefinedstrcdcStartPositionmay be undefinedStringCdcStartPositionmay be undefinedstringCdcStartPositionmay be undefined*string#
Indicates when you want a change data capture (CDC) operation to start.
cdcStartTimemay be undefinednumbercdc_start_timemay be undefinedint | floatcdcStartTimemay be undefinedNumberCdcStartTimemay be undefineddoubleCdcStartTimemay be undefined*float64#
Indicates the start time for a change data capture (CDC) operation.
cdcStopPositionmay be undefinedstringcdc_stop_positionmay be undefinedstrcdcStopPositionmay be undefinedStringCdcStopPositionmay be undefinedstringCdcStopPositionmay be undefined*string#
Indicates when you want a change data capture (CDC) operation to stop.
CFN_RESOURCE_TYPE_NAMEstringcfn_resource_type_namestrCFN_RESOURCE_TYPE_NAMEStringCFN_RESOURCE_TYPE_NAMEstringCFN_RESOURCE_TYPE_NAME*stringstatic#
The CloudFormation resource type name for this resource class.
Options for this resource, such as condition, update policy etc.
cfnResourceTypestringcfn_resource_typestrcfnResourceTypeStringCfnResourceTypestringCfnResourceType*string#
AWS resource type.
creationStackstring[]creation_stacktyping.List[str]creationStackList<String>CreationStackstring[]CreationStack*[]*string#
logicalIdstringlogical_idstrlogicalIdStringLogicalIdstringLogicalId*string#
The logical ID for this CloudFormation stack element.

The logical ID of the element is calculated from the path of the resource node in the construct tree.

To override this value, use overrideLogicalId(newLogicalId).

migrationTypestringmigration_typestrmigrationTypeStringMigrationTypestringMigrationType*string#
The migration type.
nodeNodenodeNodenodeNodeNodeNodeNodeNode#
The tree node.
refstringrefstrrefStringRefstringRef*string#
Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

If, by any chance, the intrinsic reference of a resource is not a string, you could coerce it to an IResolvable through Lazy.any({ produce: resource.ref }).

replicationInstanceArnstringreplication_instance_arnstrreplicationInstanceArnStringReplicationInstanceArnstringReplicationInstanceArn*string#
The Amazon Resource Name (ARN) of a replication instance.
replicationTaskIdentifiermay be undefinedstringreplication_task_identifiermay be undefinedstrreplicationTaskIdentifiermay be undefinedStringReplicationTaskIdentifiermay be undefinedstringReplicationTaskIdentifiermay be undefined*string#
An identifier for the replication task.
replicationTaskRefReplicationTaskReferencereplication_task_refReplicationTaskReferencereplicationTaskRefReplicationTaskReferenceReplicationTaskRefReplicationTaskReferenceReplicationTaskRefReplicationTaskReference#
A reference to a ReplicationTask resource.
replicationTaskSettingsmay be undefinedstringreplication_task_settingsmay be undefinedstrreplicationTaskSettingsmay be undefinedStringReplicationTaskSettingsmay be undefinedstringReplicationTaskSettingsmay be undefined*string#
Overall settings for the task, in JSON format.
resourceIdentifiermay be undefinedstringresource_identifiermay be undefinedstrresourceIdentifiermay be undefinedStringResourceIdentifiermay be undefinedstringResourceIdentifiermay be undefined*string#
A display name for the resource identifier at the end of the `EndpointArn` response parameter that is returned in the created `Endpoint` object.
sourceEndpointArnstringsource_endpoint_arnstrsourceEndpointArnStringSourceEndpointArnstringSourceEndpointArn*string#
An Amazon Resource Name (ARN) that uniquely identifies the source endpoint.
stackStackstackStackstackStackStackStackStackStack#
The stack in which this element is defined.

CfnElements must be defined within a stack scope (directly or indirectly).

tableMappingsstringtable_mappingsstrtableMappingsStringTableMappingsstringTableMappings*string#
The table mappings for the task, in JSON format.
Tag Manager which manages the tags for this resource.
tagsRawmay be undefinedCfnTag[]tags_rawmay be undefinedtyping.List[CfnTag]tagsRawmay be undefinedList<CfnTag>TagsRawmay be undefinedCfnTag[]TagsRawmay be undefined*[]CfnTag#
One or more tags to be assigned to the replication task.
targetEndpointArnstringtarget_endpoint_arnstrtargetEndpointArnStringTargetEndpointArnstringTargetEndpointArn*string#
An Amazon Resource Name (ARN) that uniquely identifies the target endpoint.
taskDatamay be undefinedstringtask_datamay be undefinedstrtaskDatamay be undefinedStringTaskDatamay be undefinedstringTaskDatamay be undefined*string#
Supplemental information that the task requires to migrate the data for certain source and target endpoints.

Methods ​

addDeletionOverride(path: string): voiddef add_deletion_override(self, path: str) -> Nonepublic void addDeletionOverride(String path)public void AddDeletionOverride(string path)func AddDeletionOverride(Path *string)#
Syntactic sugar for `addOverride(path, undefined)`.
1 parameter

Parameters

  • pathpathpathpathPath — The path of the value to delete.
addDependency(target: CfnResource): voiddef add_dependency(self, target: CfnResource) -> Nonepublic void addDependency(CfnResource target)public void AddDependency(CfnResource target)func AddDependency(Target CfnResource)deprecated#
Use `addResourceDependency` instead.

This method has been renamed to addResourceDependency to more clearly set it apart from construct.node.addDependency. See the documentation of that function for more details.

addDependsOn(target: CfnResource): voiddef add_depends_on(self, target: CfnResource) -> Nonepublic void addDependsOn(CfnResource target)public void AddDependsOn(CfnResource target)func AddDependsOn(Target CfnResource)deprecated#
Use `addResourceDependency` instead.
notes

This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.

This method has been renamed to addResourceDependency, which makes it more clear that this method operates at a different level from the construct-level construct.node.addDependency() mechanism.

addMetadata(key: string, value: any): voiddef add_metadata(self, key: str, value: Any) -> Nonepublic void addMetadata(String key, Object value)public void AddMetadata(string key, object value)func AddMetadata(Key *string, Value interface{})#
Add a value to the CloudFormation Resource Metadata.
addOverride(path: string, value: any): voiddef add_override(self, path: str, value: Any) -> Nonepublic void addOverride(String path, Object value)public void AddOverride(string path, object value)func AddOverride(Path *string, Value interface{})#
Adds an override to the synthesized CloudFormation resource.
notes · 2 parameters

To add a property override, either use addPropertyOverride or prefix path with "Properties." (i.e. Properties.TopicName).

If the override is nested, separate each nested level using a dot (.) in the path parameter. If there is an array as part of the nesting, specify the index in the path.

To include a literal . in the property name, prefix with a \. In most programming languages you will need to write this as "\\." because the \ itself will need to be escaped.

For example,

typescript
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');

would add the overrides

json
"Properties": {
  "GlobalSecondaryIndexes": [
    {
      "Projection": {
        "NonKeyAttributes": [ "myattribute" ]
        ...
      }
      ...
    },
    {
      "ProjectionType": "INCLUDE"
      ...
    },
  ]
  ...
}

The value argument to addOverride will not be processed or translated in any way. Pass raw JSON values in here with the correct capitalization for CloudFormation. If you pass CDK classes or structs, they will be rendered with lowercased key names, and CloudFormation will reject the template.

Parameters

  • pathpathpathpathPath — - The path of the property, you can use dot notation to override values in complex types.
  • valuevaluevaluevalueValue — - The value.
addPropertyDeletionOverride(propertyPath: string): voiddef add_property_deletion_override(self, property_path: str) -> Nonepublic void addPropertyDeletionOverride(String propertyPath)public void AddPropertyDeletionOverride(string propertyPath)func AddPropertyDeletionOverride(PropertyPath *string)#
Adds an override that deletes the value of a property from the resource definition.
1 parameter

Parameters

  • propertyPathproperty_pathpropertyPathpropertyPathPropertyPath — The path to the property.
addPropertyOverride(propertyPath: string, value: any): voiddef add_property_override(self, property_path: str, value: Any) -> Nonepublic void addPropertyOverride(String propertyPath, Object value)public void AddPropertyOverride(string propertyPath, object value)func AddPropertyOverride(PropertyPath *string, Value interface{})#
Adds an override to a resource property.

Syntactic sugar for addOverride("Properties.<...>", value).

2 parameters

Parameters

  • propertyPathproperty_pathpropertyPathpropertyPathPropertyPath — The path of the property.
  • valuevaluevaluevalueValue — The value.
addResourceDependency(target: CfnResource, reason?: string): voiddef add_resource_dependency(self, target: CfnResource, reason: typing.Optional[str] = None) -> Nonepublic void addResourceDependency(CfnResource target, String reason)public void AddResourceDependency(CfnResource target, string? reason = null)func AddResourceDependency(Target CfnResource, Reason *string)#
Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.
notes

This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.

This method only adds dependencies between L1 resources. If you are looking for a generic construct-to-construct dependency mechanism that works for all constructs including L2s, use construct.node.addDependency instead.

applyCrossStackReferenceStrength(strength: ReferenceStrength): voiddef apply_cross_stack_reference_strength(self, strength: ReferenceStrength) -> Nonepublic void applyCrossStackReferenceStrength(ReferenceStrength strength)public void ApplyCrossStackReferenceStrength(ReferenceStrength strength)func ApplyCrossStackReferenceStrength(Strength ReferenceStrength)#
Sets the cross-stack reference strength for this resource.

When set, any cross-stack reference to this resource will use the specified strength instead of the global default from the consuming stack's context.

1 parameter

Parameters

  • strengthstrengthstrengthstrengthStrength — - The reference strength to use for this resource.
applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): voiddef apply_removal_policy(self, policy: typing.Optional[RemovalPolicy] = None, options: typing.Optional[RemovalPolicyOptions] = None) -> Nonepublic void applyRemovalPolicy(RemovalPolicy policy, RemovalPolicyOptions options)public void ApplyRemovalPolicy(RemovalPolicy? policy = null, RemovalPolicyOptions? options = null)func ApplyRemovalPolicy(Policy RemovalPolicy, Options RemovalPolicyOptions)#
Sets the deletion policy of the resource based on the removal policy specified.
notes

The Removal Policy controls what happens to this resource when it stops being managed by CloudFormation, either because you've removed it from the CDK application or because you've made a change that requires the resource to be replaced.

The resource can be deleted (RemovalPolicy.DESTROY), or left in your AWS account for data recovery and cleanup later (RemovalPolicy.RETAIN). In some cases, a snapshot can be taken of the resource prior to deletion (RemovalPolicy.SNAPSHOT). A list of resources that support this policy can be found in the following link:

arnForReplicationTask(resource: IReplicationTaskRef): string@staticmethod def arn_for_replication_task(resource: IReplicationTaskRef) -> strpublic static String arnForReplicationTask(IReplicationTaskRef resource)public static string ArnForReplicationTask(IReplicationTaskRef resource)func ArnForReplicationTask(Resource IReplicationTaskRef) *stringstatic#
cfnPropertyName(cdkPropertyName: string): stringdef cfn_property_name(self, cdk_property_name: str) -> strpublic String cfnPropertyName(String cdkPropertyName)public string CfnPropertyName(string cdkPropertyName)func CfnPropertyName(CdkPropertyName *string) *string#
getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Referencedef get_att(self, attribute_name: str, type_hint: typing.Optional[ResolutionTypeHint] = None) -> Referencepublic Reference getAtt(String attributeName, ResolutionTypeHint typeHint)public Reference GetAtt(string attributeName, ResolutionTypeHint? typeHint = null)func GetAtt(AttributeName *string, TypeHint ResolutionTypeHint) Reference#
Returns a token for an runtime attribute of this resource.

Ideally, use generated attribute accessors (e.g. resource.arn), but this can be used for future compatibility in case there is no generated attribute.

1 parameter

Parameters

  • attributeNameattribute_nameattributeNameattributeNameAttributeName — The name of the attribute.
getMetadata(key: string): anydef get_metadata(self, key: str) -> Anypublic Object getMetadata(String key)public object GetMetadata(string key)func GetMetadata(Key *string) interface{}#
Retrieve a value value from the CloudFormation Resource Metadata.
inspect(inspector: TreeInspector): voiddef inspect(self, inspector: TreeInspector) -> Nonepublic void inspect(TreeInspector inspector)public void Inspect(TreeInspector inspector)func Inspect(Inspector TreeInspector)#
Examines the CloudFormation resource and discloses attributes.
1 parameter

Parameters

  • inspectorinspectorinspectorinspectorInspector — tree inspector to collect and process attributes.
isCfnElement(x: any): boolean@staticmethod def is_cfn_element(x: Any) -> boolpublic static Boolean isCfnElement(Object x)public static bool IsCfnElement(object x)func IsCfnElement(X interface{}) *boolstatic#
Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

Uses duck-typing instead of instanceof to allow stack elements from different versions of this library to be included in the same stack.

returns

Returns: The construct as a stack element or undefined if it is not a stack element.

isCfnReplicationTask(x: any): boolean@staticmethod def is_cfn_replication_task(x: Any) -> boolpublic static Boolean isCfnReplicationTask(Object x)public static bool IsCfnReplicationTask(object x)func IsCfnReplicationTask(X interface{}) *boolstatic#
Checks whether the given object is a CfnReplicationTask.
isCfnResource(x: any): boolean@staticmethod def is_cfn_resource(x: Any) -> boolpublic static Boolean isCfnResource(Object x)public static bool IsCfnResource(object x)func IsCfnResource(X interface{}) *boolstatic#
Check whether the given object is a CfnResource.
isConstruct(x: any): boolean@staticmethod def is_construct(x: Any) -> boolpublic static Boolean isConstruct(Object x)public static bool IsConstruct(object x)func IsConstruct(X interface{}) *boolstatic#
Checks if `x` is a construct.
notes · 1 parameter · returns

Use this method instead of instanceof to properly detect Construct instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the constructs library on disk are seen as independent, completely different libraries. As a consequence, the class Construct in each copy of the constructs library is seen as a different class, and an instance of one class will not test as instanceof the other class. npm install will not create installations like this, but users may manually symlink construct libraries together or use a monorepo tool: in those cases, multiple copies of the constructs library can be accidentally installed, and instanceof will behave unpredictably. It is safest to avoid using instanceof, and using this type-testing method instead.

Parameters

  • xxxxX — Any object.

Returns: true if x is an object created from a class which extends Construct.

obtainDependencies(): Stack | CfnResource[]def obtain_dependencies(self, ) -> typing.List[typing.Union[Stack, CfnResource]]public List<Stack> obtainDependencies()public Stack[] ObtainDependencies()func ObtainDependencies() *[]interface{}#
Retrieves an array of resources and stacks this resource depends on.

For resources depended on directly, returns the CfnResource object. For dependencies on other stacks, returns the Stack object. The order of the array is not guaranteed.

overrideLogicalId(newLogicalId: string): voiddef override_logical_id(self, new_logical_id: str) -> Nonepublic void overrideLogicalId(String newLogicalId)public void OverrideLogicalId(string newLogicalId)func OverrideLogicalId(NewLogicalId *string)#
Overrides the auto-generated logical ID with a specific ID.
1 parameter

Parameters

  • newLogicalIdnew_logical_idnewLogicalIdnewLogicalIdNewLogicalId — The new logical ID to use for this stack element.
removeDependency(target: CfnResource): voiddef remove_dependency(self, target: CfnResource) -> Nonepublic void removeDependency(CfnResource target)public void RemoveDependency(CfnResource target)func RemoveDependency(Target CfnResource)deprecated#
Use `removeResourceDependency` instead

This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.

removeResourceDependency(target: CfnResource): voiddef remove_resource_dependency(self, target: CfnResource) -> Nonepublic void removeResourceDependency(CfnResource target)public void RemoveResourceDependency(CfnResource target)func RemoveResourceDependency(Target CfnResource)#
Indicates that this resource no longer depends on another resource.

This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.

replaceDependency(target: CfnResource, newTarget: CfnResource): voiddef replace_dependency(self, target: CfnResource, new_target: CfnResource) -> Nonepublic void replaceDependency(CfnResource target, CfnResource newTarget)public void ReplaceDependency(CfnResource target, CfnResource newTarget)func ReplaceDependency(Target CfnResource, NewTarget CfnResource)#
Replaces one dependency with another.
2 parameters

Parameters

  • targettargettargettargetTarget — The dependency to replace.
  • newTargetnew_targetnewTargetnewTargetNewTarget — The new dependency to add.
toString(): stringdef to_string(self, ) -> strpublic String toString()public string ToString()func ToString() *string#
Returns a string representation of this construct.
returns

Returns: a string representation of this resource

with(...mixins: IMixin[]): IConstructdef with(self, mixins: IMixin) -> IConstructpublic IConstruct with(IMixin mixins)public IConstruct With(IMixin mixins)func With(Mixins IMixin) IConstruct#
Applies one or more mixins to this construct.

Mixins are applied in order. The list of constructs is captured at the start of the call, so constructs added by a mixin will not be visited. Use multiple with() calls if subsequent mixins should apply to added constructs.